#include "POP.h"
#include "mailbox.h"
#include "treeview.h"
#include <pthread.h>

extern unsigned char nbboites;
extern boite *b;
extern check *c;

/*==============================================================================
  Thread de connection au serveur.
  Chaque minute, pour chaque boite, décrémente next_check de 1.
  Quand next_check = 0, se connecte et remet next_check à l'intervalle voulu.
  Un intervalle à 0 désactive le check.
==============================================================================*/
gboolean check_POP(gboolean periodique)
{
  register int n;

  //printf("check\n");
  for (n=0; n<nbboites; n++)
  {
    //printf("\t%s intervalle=%d nextcheck=%d\n", b[n].nom, b[n].intervalle, c[n].next_check);
    if (b[n].intervalle && --c[n].next_check == 0)
    {
      //say("check"); say(b[n].nom);
      //printf("check %s ...\n", b[n].nom);
      pop3_connect(n); // nouveaux messages?
      c[n].next_check = b[n].intervalle;
    }
  }
  ecrire_fichier_data();

  return periodique;
}
/*==============================================================================
  le thread
==============================================================================*/
void *thread_check()
{
  register int n;

  while (1)
  {
    //printf("check\n");
    for (n=0; n<nbboites; n++)
    {
      //printf("\t%s intervalle=%d nextcheck=%d\n", b[n].nom, b[n].intervalle, c[n].next_check);
      if (b[n].intervalle && --c[n].next_check == 0)
      {
        //say("check"); say(b[n].nom);
        //printf("check %s ...\n", b[n].nom);
        pop3_connect(n); // nouveaux messages?
        c[n].next_check = b[n].intervalle;
      }
    }
    //ecrire_fichier_data();
    sleep(60);
  }
}
/*==============================================================================
  Affiche le numéro d'erreur du socket, en cas de problème
==============================================================================* /
void on_error(char *msg)
{
  char str[255];
  sprintf(str, "Error in function %s, err number: %d\n", msg, WSAGetLastError());
  MessageBox (hwnd,str,"Speech POP3 Error",MB_OK | MB_ICONEXCLAMATION);

  //say(str);

  //add to log file
}
/*==============================================================================
  Se connecte au serveur puis envoie des commandes POP3
==============================================================================*/
void pop3_connect (int x)
{
  char buf[255]; // paquet envoyé au serveur
  int i=-1;      // valeurs de retour

  SOCKET sk = connection_TCP(b[x].POPserveur, b[x].POPport);

  // Envoi des commandes POP3
  i = sprintf(buf, "USER %s\r\n", b[x].email); mail_discuss(sk,buf,i,0,x);
  i = sprintf(buf, "PASS %s\r\n", b[x].mdp  ); mail_discuss(sk,buf,i,1,x);
  //i = sprintf(buf, "APOP %s %s\r\n", b[x].n, md5(b[x].p)); mail_discuss(sk,buf,i,1,x);
  i = sprintf(buf, "STAT\r\n");                mail_discuss(sk,buf,i,2,x);
  i = sprintf(buf, "QUIT\r\n");                mail_discuss(sk,buf,i,3,x);

  closesocket(sk);
}
/*==============================================================================
  Recoit une réponse du serveur puis envoie une nouvelle commande.
  Paramètres:
   - sk est le descripteur du socket actuellement connecté au serveur
   - msg est la commande à envoyer: "USER n", "PASS n", "STAT", ou "QUIT"
   - len est la longueur de la commande à envoyer, utile pour send().
   - Le 'stade' détermine la commande fatidique qui indique le paquet comportant
     les infos qui nous intéressent, par exemple "+OK 25 12544" qui signifie
     "vous avez 25 messages qui occupent 12544 octets"
   - x est l'index de la boite traitée
==============================================================================*/
static void mail_discuss (SOCKET sk, char *msg, int len, char stade, int x)
{
  char s[1500]; // les serveurs envoient rarement plus de 1500 octets/paquet

  int i = recv (sk, s, sizeof(s), 0);

  if (i && stade==3)
  {
    s[i]=0;
    //printf("> %s\n", s);

    // Découpe "+OK 25 12544" en 3, rapidement sans strtok()

    //int nbmsg=0;
    //double nboctets=0;
    //sscanf (s,"%*s %d %lf\n", &nbmsg, &nboctets);

    char d[3][255]; int n, cpt=0, a=0;
    for (n=0; n<i-1; n++)
    {
      if (s[n]==' ' || n==i-2) {d[cpt][a]=0; a=0; cpt++;}
      else {d[cpt][a++]=s[n];}
    }
    n = atoi(d[1]);
    //printf("%d mails != %d ?\n", n, c[x].nbmessages);
    // Si le nombre de messages est différent depuis la dernière connection
    // pour cette boite, met à jour le tableau et l' affichage 
    if (n != c[x].nbmessages)
    {
/*
      // Transforme 12544 en "12.25Ko"
      double nboctets = atof(d[2]);
      if (nboctets)
      {
        //char octets[100];
        if (nboctets < 1024)
               sprintf(c[x].taille_msg, " (%s octets)", d[1]);
        else if (nboctets < 1048576)
               sprintf(c[x].taille_msg, " (%.1lf Ko)", nboctets/1024);
        else   sprintf(c[x].taille_msg, " (%.1lf Mo)", nboctets/1024/1024);
      }

      sprintf(s,"%s: %s email%s\n",
                            b[x].nom,
                           (n<1)?"Pas d'":d[1], 
                           (n>1)?"s":"",
                           (n>0)?c[x].taille_msg:".");
//      SetDlgItemText(hwnd, 404, s);
//printf("%s", s);
*/
      c[x].nbmessages = n;

      // Récupère chaque nouveau message. Ok 1re connection: on a 200 msg.
      // Downloade les mails de 1 à 200, puis stocke 200. Connection suivante:
      // voit qu'on a 250 msg. Récupère mails de 201 à 250 et stocke 250.

      int a = (b[x].nb == -1) ? 0 : b[x].nb;
      int depart = a + 1; // 1 ou 201
      int nbarecuperer = n - (depart-1); // 200 - 0 donc 200  ou 250 - 200 donc 50 ou 200-200=0
      //printf("donc recup %d a %d (%d a recuperer)\n", depart, n, nbarecuperer);
      if (depart <= n)
      {
        //printf("\tnb:%d depart:%d nbarecuperer:%d\n", nb, depart, nbarecuperer);
        //printf("Recup de %d a %d (%d a recuperer)\n", depart, n, nbarecuperer);

        // DIS-LE
        sprintf(msg, "email pour %s, %d nouveau message%s",
        //sprintf(msg, "Mailbox, %s, you have %d new message%s",
                   b[x].nom, nbarecuperer, (nbarecuperer>1)?"s":""); //d[1] total


//printf("%s\n", msg);
        dire(msg);


        //printf("bxnb=%d\n", b[x].nb);
        for (i=depart; i<=n; i++)
        {
          //printf("%d/%d ...\n", i, nbarecuperer);
          getmsg(sk, i, x); //récupère et analyse message i de la boite x

          //if (laissePasSurServeur)
              //supprmsg(sk,n, x);

          // stocke nombre de messages en boite
          b[x].nb = i;
//printf("ecrire\n");
          // c'est là où il faut stocker
          //ecrire_fichier_data();

          //change le nombre d'emails dans la liste
          extern GtkWidget *liste;
          char num[10];
          sprintf(num, "%d", i);
          gtk_clist_set_text ((GtkCList *)liste, x, 1, (const gchar *)num);

          //printf("mail_discuss() appel ecrire %s nb=%d\n", b[x].nom, i);
        }

        // c'est là où il faut stocker
        ecrire_fichier_data();

      }
      //printf("\tnext check in %d minutes\n", b[x].intervalle);
    }
  }

  // Envoie au serveur la commande spécifiée en argument
//printf("<%s\n", msg);
  i = send(sk, msg, len, 0);
  if (i != len) socket_error("send()");
  
  // Et attend le temps que le serveur la traite. Ce sleep garantit que les
  // paquets reçus seront dans le bon ordre, avec 0% CPU.
  #ifdef WIN32
   sleep(100); //100ms
  #else
   //sleep(1); //1s
   usleep(10000); //100ms
  #endif
}
/*==============================================================================
  commande STAT : nombre de messages taille totale en octets
==============================================================================*
int getSTAT(SOCKET sk)
{
  char buf[512];
  int i=0,taille=0, nb=0;

  i = send(sk, "STAT\r\n", 6, 0);
  if (i != 6) on_error("send(STAT)");

  i = recv(sk, buf, sizeof(buf), 0);
  buf[i]=0;

  //printf("-->getStat (%d octets)\n", i, buf);
  sscanf (buf,"+OK %d %d\n", &nb, &taille);
  //printf("-->getSTAT %s\nVous avez %d messages, %d octets\n", buf, nb, taille);
  return nb;
}
/*==============================================================================
  RECEVOIR UN EMAIL
==============================================================================*/
static void getmsg(SOCKET sk, int idmail, int boite)
{
  char buf[2048];
  int i=0, n;

  n = sprintf(buf,"RETR %d\r\n", idmail);
  i = send(sk, buf, n, 0);
  if (i != n) socket_error("send(RETR)");

  char str[128];
  sprintf(str, "/usr/local/etc/POPspeech/mails/%s", b[boite].nom);
  if (!is_dir(str)) mkdir(str);

  sprintf(str,"%s/%d.txt", str, idmail);
  //printf("\trecup [%s]...\n", str);
//printf("recv\n");
  FILE *fp = fopen(str,"w");
  while ((i = recv(sk, buf, sizeof(buf), 0)))
  {
    buf[i]=0;
    fprintf(fp,"%s", buf);
    if (buf[i-2]==0XD && buf[i-3]=='.' && buf[i-4]==0XA) break;
  }
  fclose(fp);
//printf("getcontents\n");
  // parse le mesage en local
  char* s = file_get_contents(str);
  if (s)
  {
    long len = strlen(s);
//printf("parse\n");
    parsemsg(s, len, boite, idmail);
    free(s);
  }

}

/*==============================================================================
  vide la boite complètement sur le serveur
==============================================================================* /
void effacer_messages_du_serveur()
{
  // le message a été intégralement reçu: le supprime sur le serveur
  
  //ou alors : il y a x msg sur le serveur, boucle de 1 à x pour envoi de DELE
  n = sprintf(buf,"DELE %d\r\n", idmail);
  i = send(sk, buf, n, 0);
  i = recv(sk, buf, sizeof(buf), 0);
  printf("%s\n", buf);
}

/*==============================================================================
  Parsing header SMTP : from/subject/date/content-type sont extraits pour
  ajouter un item au listview, cette entrée est aussi stockée dans le csv, le
  tout si boite vaut pas -1. Sinon il s'agit d'un clic sur un item de listview,
  il faut donc utiliser les résultats du parsing pour parser le contenu du
  message, le header etant dejà parsé ci-dessous
==============================================================================*/
int parsemsg(char *s, long len, int boite, int idmail)
{
  char prem=1; //c'est la 1re lettre de la ligne?
  char dpt =0; //deux points trouvés. ne compare un mot que si ce mot est en début de ligne
  char ign =0; //ignorer cette ligne, car 1re lettre est tab ou espace
  char prn =0; //mot trouvé: maintenant stocker sa valeur
  char mot[2048]; //une ligne lue
  short k=0;
  long n;

  static const char *mots[5] = {
      "from",
      "subject",
      "date",
      "content-type", //text/plain ou text/html?
      "content-transfer-encoding" //quoted-printable?
  };

  char* lefrom = NULL;
  char* lesuje = NULL;
  char* ledate = NULL;

  int header  = 0; // 1 indique que le header est passé, valeur indique debut du contenu
  char isHTML = 0;
  char isQP   = 0; // quoted-printable
  char cpt    = 0;

  for (n=0; n<len; n++)
  {
    //la 1re lettre de la ligne est un tab ou espace: ignorer la ligne
    if (prem)
    {
      if (s[n]=='\t' || s[n]==' ' || s[n]=='+') ign=1;
      prem = 0;
    }

    //else if (s[n]=='\n');
    else if (s[n]=='\r') // fin de la ligne. si valeur à prendre, la prend
    {
      // fin du header 6 chars \r\r\n\r\r\n stocker position
      if ( header==0 &&      s[n+1] == '\n' && s[n+2] == '\r' &&
           s[n+3] == '\n' && s[n+4] == '\r' && s[n+5] == '\n')
      {
        n += 6;
        header = n;
//printf("HEADER:%d\n", n);
//break;
      }

      if (prn != 0)
      {
        mot[k]=0;
//printf("{%s}\n", mot);

        if      (cpt==0) // ----------------------------------------------- FROM
        {
          if (lefrom) free(lefrom);
          lefrom = strdup(mot);
//printf("\tfrom:%s\n", lefrom);
        }

        else if (cpt==1) // ---------------------------------------------- SUJET
        {
          if (lesuje) free(lesuje);
          // clean "=?iso-8859-1?Q?CodeS-SourceS du 26/08/2009?="
          if (mot[0]=='=' && mot[1]=='?')
          {
            mot[k-2] = 0; // coupe la fin ?=
            int r;
            for (r=2; r<k-2; r++) if (mot[r]=='?') break;
            r += 3;
            lesuje = convert_quoted_printable(mot+r, k-r);
            //lesuje = strdup(mot+r);
          }
          else lesuje = strdup(mot);
        }

        else if (cpt==2) // ----------------------------------------------- DATE
        {
          if (ledate) free(ledate);
          ledate = strdup(mot);
        }

        else if (cpt==3) // --------------------------------------- CONTENT-TYPE
        {
          if (!strncmp("text/html", mot, 9)) isHTML = 1;
        }

        else if (cpt==4) // -------------------------- CONTENT-TRANSFER-ENCODING
        {
          if (!strncmp("quoted-printable", mot, 16))
            isQP = 1;
        }

        prn = 0;
      }
      prem = 1;
      k = dpt = 0;
      //n++;
      continue;
    }

    else if (s[n]==':' && dpt==0) // nom trouvé!
    {
      mot[k]=0;
//printf("MOT:[%s]\n", mot);
      unsigned char m;
      for (m=0; m<5; m++)
      {
        if (!strcmp(mot,mots[m]))
        {
          //printf("(%s) ", mots[m]);
          n++; //ignorer l'espace de From: machin
          cpt = m;
          prn=1;
          
          // ici avancer jusqu'à \r pour recuperer la valeur direct!
	  while (s[n]==' ' || s[n]=='\r' || s[n]=='\n' || s[n]=='\t') { n++; }
          n--;
          break;
        }
      }
      k=0;
      dpt=1;
    }
 
    //garde la lettre, mais en minuscule
    else if (ign == 1) mot[k++]=(s[n]>64 && s[n]<92) ? s[n]+32 : s[n];
  }

  //printf("boite:%d\n", boite);

  // reception d'un message, l'entrée est ajoutée au listview et au CSV
  if (boite != -1)
  {
    char idm[33];
    //char * itoa (int __val, char *__s, int __radix)
    //itoa (idmail,idm,10);
    sprintf(idm, "%d", idmail);
    //ListView_AjoutItem(hwndLV, lefrom, b[boite].nom, lesuje, ledate, idm);
    //printf("%s %s %s %s %s\n", lefrom, b[boite].nom, lesuje, ledate, idm);

//    gchar* sujet_utf8 = g_convert (lesuje, -1, "UTF-8", "ISO-8859-1", NULL, NULL, NULL);
    //gchar* sujet_utf8 = g_locale_to_utf8(lesuje, -1, NULL, NULL, NULL);

    //printf("\nfrom:[%s]\nto:[%s]\nsujet:[%s]\ndate:[%s]\n", lefrom, b[boite].nom, sujet_utf8, ledate);

//    listview_add_enregistrement(lefrom, b[boite].nom, sujet_utf8, ledate, idmail);
   // g_free(sujet_utf8);
/*
printf("FROM:[%s]\n", lefrom);
printf("POUR:[%s]\n", b[boite].nom);
printf("SUJE:[%s]\n", lesuje);
printf("DATE:[%s]\n", ledate);
printf("IDMA:[%s]\n", idm);
*/
      gchar* fro_utf8 = g_locale_to_utf8(lefrom      , -1, NULL, NULL, NULL);
      gchar* nom_utf8 = g_locale_to_utf8(b[boite].nom, -1, NULL, NULL, NULL);
      gchar* suj_utf8 = g_locale_to_utf8(lesuje      , -1, NULL, NULL, NULL);
      gchar* dat_utf8 = g_locale_to_utf8(ledate      , -1, NULL, NULL, NULL);
      gchar* idm_utf8 = g_locale_to_utf8(idm         , -1, NULL, NULL, NULL);
      listview_add_enregistrement(fro_utf8, nom_utf8, suj_utf8, dat_utf8, idm_utf8);
      g_free(fro_utf8);
      g_free(nom_utf8);
      g_free(suj_utf8);
      g_free(dat_utf8);
      g_free(idm_utf8);


//printf("fopen\n");
    // 0x1F : Unit Separator, 31 en decimal
    FILE* fp = fopen("/usr/local/etc/POPspeech/mails.csv","a");
    //fprintf(fp,"ok\n");
    fprintf(fp,"%s%c%s%c%s%c%s%c%d\n",
              lefrom,0x1F, b[boite].nom,0x1F, lesuje,0x1F, ledate,0x1F, idmail);
//printf("fclsoe\n");
    fclose(fp);
  }

  // parse suite au clic sur listview
  else
  {
    char *str = NULL;
    //printf("header:%d\n", header);
    // si content-type est HTML, vire les balises
    if (isHTML == 1)
    {
      int l = len-header;
      str = virer_html(s+header, l);
      //str[l-3] = 0;
    }
    else str = s+header;

    if (isQP)
    {
      char* str2 = convert_quoted_printable(str, strlen(str));
      free(str);
      str = str2;
    }

    // si fichiers attachés, les met en quarantaine temporairement

    // si image jpg/png la transforme en bmp
    
    // l'affiche
//    SetDlgItemText(hwnd, 301, str);
    //free(s);
  }

  if (lefrom) free(lefrom);
  if (lesuje) free(lesuje);
  if (ledate) free(ledate);
}
/*==============================================================================
  Transforme "<td><font color=yellow>BOB</font></td>" En "BOB"
==============================================================================*/
char *virer_html(char *s, int len)
{
  int flag=0, b=0, m=0;
  char *str = NULL;

  // Fait un premier passage pour savoir combien d'octets fera str
  for (b=0; b<len; b++)
  {
    if      (s[b]=='<') flag=0;
    else if (s[b]=='>') flag=1;
    else if (flag) m++;
  }

  // Lui alloue son espace
  str = malloc(m+1);

  // Parcourt la chaîne pour y transférer les bons octets
  flag=b=0;
  while (*s)
  {
    if      (*s=='<') flag=0;
    else if (*s=='>') flag=1;
    else if (flag) str[b++]=*s;
    *s++;
  }
  str[b]=0;
  return str;
}
/*==============================================================================
  transforme "d=E9pos=E9s" en "déposés"
==============================================================================*/
char* convert_quoted_printable(char* s, int len)
{
  char* s2 = strdup(s);

  int n, n2=0;
  for (n=0; n<len; n++)
  {
    if (s[n]=='=')
    {
      char c[3];
      c[0] = s[n+1];
      c[1] = s[n+2];

      if (c[0] == '\r' && c[1]=='\n')
      {
        n += 2;
        continue;
      }

      c[2]=0;

      char *end;
      long l = strtol (c,&end,16);
      //printf("=%s -> %ld -> %c\n", c, l, l);
      sprintf(c,"%c", (int)l);
      s2[n2] = c[0];

      n2++;
      n += 2;
    }
    else s2[n2++] = s[n];
  }

  s2[n2] = 0;
  return s2;
}
/*==============================================================================

==============================================================================*
void mails2csv()
{
  char* s = file_get_contents("mails/Katsankat/1.txt");
  int len = strlen(s);

  parsemsg(s, len);

  free(s);
}
*/

