// gcc -Wall main.c mailbox.c TCPsocket.c POP.c treeview.c -o test -lpthread && ./test
#include <pthread.h>
#include <gtk/gtk.h>
#include "treeview.h"
#include "mailbox.h"
#include "POP.h"

boite *b; // stockées
check *c; // valeurs pour check seulement
unsigned char nbboites; // 255 boites maxi!
char reset = 0;  // si mails.csv n'existe pas, repart à zero

int selectedindex = -1;

GtkWidget *liste = NULL;
GtkWidget *txtNom=NULL, *txtPOPserveur=NULL, *txtPOPport=NULL, 
          *txtSMTPserveur=NULL, *txtSMTPport=NULL, 
          *txtemail=NULL, *txtMdp=NULL, *txtCheckmn=NULL;


/*==============================================================================

==============================================================================*/
void *synthese_vocale(void *ptr)
{
  char s[512];
  char * msg = (char *) ptr;
  //sprintf(s, "echo \"%s\" | festival --tts", msg);
  //sprintf(s, "echo \"%s\" | espeak -s 160 -g 15 -p 20 -v fr", msg);
  //sprintf(s, "echo \"%s\" | espeak -v fr", msg);
  sprintf(s, "espeak -v mb-fr1 \"%s\" | mbrola /opt/mbrola/fr6/fr6 - - | aplay -r16000 -fs16", msg);
  system(s);
}
/*==============================================================================
  Lance un thread pour synthèse vocale
==============================================================================*/
void dire(char *msg)
{
  pthread_t t;
  int iret1 = pthread_create( &t, NULL, synthese_vocale, (void*) msg);
  //pthread_join(t, NULL);
}
/*==============================================================================

==============================================================================*/
static void cb_status_icon_activate (GtkStatusIcon * statusicon, gpointer data)
{
 GtkWidget *fen = data;

 g_return_if_fail (fen != NULL);
 g_return_if_fail (GTK_IS_WIDGET (fen));

 if (GTK_WIDGET_VISIBLE (fen))
 {
  gtk_widget_hide (fen);
  //gtk_status_icon_set_from_file(statusicon,"img/50_ico_3.ico");
 }
 else
 {
  gtk_widget_show (fen);
  //gtk_status_icon_set_from_file(statusicon,"sys.gif");
 }
}

/*==============================================================================

==============================================================================*/
static void liste_click(GtkWidget *liste, gint row, gint column,
		 GdkEventButton *event, gpointer data)
{
    gchar *text;
 
    selectedindex = row;

    gtk_clist_get_text (GTK_CLIST (liste), row, column, &text);

    //g_print ("You selected row %d. More specifically you clicked in "
    //         "column %d, and the text in this cell is %s\n\n", row, column, text);

    // remplit les zones de saisie
    gchar s[32];
    gtk_entry_set_text (GTK_ENTRY(txtNom)        , b[row].nom);
    gtk_entry_set_text (GTK_ENTRY(txtPOPserveur) , b[row].POPserveur);
                sprintf(s, "%d", b[row].POPport);
    gtk_entry_set_text (GTK_ENTRY(txtPOPport)    , s);
    gtk_entry_set_text (GTK_ENTRY(txtSMTPserveur), b[row].SMTPserveur);
                sprintf(s, "%d", b[row].SMTPport);
    gtk_entry_set_text (GTK_ENTRY(txtSMTPport)   , s);
    gtk_entry_set_text (GTK_ENTRY(txtemail)      , b[row].email);
    gtk_entry_set_text (GTK_ENTRY(txtMdp)        , b[row].mdp);
                sprintf(s, "%d", b[row].intervalle);
    gtk_entry_set_text (GTK_ENTRY(txtCheckmn)    , s);

    return;
}
/*==============================================================================
  Ajoute une paire label/texte
==============================================================================*/
static GtkWidget *Creer_Entry(gchar *lcaption, gint id, GtkWidget *box)
{
  GtkWidget *l, *t;

  l = gtk_label_new(NULL);
  gtk_label_set_markup(GTK_LABEL(l), g_strdup_printf(
		"<span face=\"Monospace\"><b>%s</b></span>\n", lcaption));
  gtk_label_set_justify(GTK_LABEL(l), GTK_JUSTIFY_CENTER);
  gtk_table_attach_defaults (GTK_TABLE (box), l, 0, 1, id, id+1);

  t = gtk_entry_new ();
  gtk_entry_set_max_length (GTK_ENTRY (t), 30);
  //gtk_entry_set_text (GTK_ENTRY (t), caption);
  gtk_table_attach_defaults (GTK_TABLE (box), t, 1, 2, id, id+1);

  gtk_widget_show (t);
  return t;
}
/*==============================================================================

==============================================================================*/
void create_window()
{
//printf("create window\n");
  GtkWidget *fen = NULL;
  GtkWidget *main_hpaned, *leftvbox, *table, *rightvpaned;
  GtkWidget *pScrollbar, *buttonAdd, *buttonSuppr, *buttonEdit, *buttonCheck;
  GtkStatusIcon *statusicon = NULL;
  gchar *titles[2] = { "Compte", "msg" };

  treeview_num_records = 0;

  fen = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (fen), "POPspeech GTK+");
  gtk_window_set_default_size(GTK_WINDOW(fen), 900, 400);
  gtk_window_set_position (GTK_WINDOW (fen), GTK_WIN_POS_CENTER);
  g_signal_connect (G_OBJECT (fen), "destroy", G_CALLBACK (gtk_main_quit),NULL);

  // Creation de l'icone et d'une info-bulle
  statusicon = gtk_status_icon_new_from_file ("/usr/local/etc/POPspeech/img/email.ico");
  gtk_status_icon_set_tooltip (GTK_STATUS_ICON (statusicon),"POPspeech GTK+");
  g_signal_connect (G_OBJECT (statusicon), "activate",
                    G_CALLBACK (cb_status_icon_activate), fen);


  // un grand hpaned contient les comptes à gauche, (et listview+message à droite)
  main_hpaned = gtk_hpaned_new();
  gtk_container_add (GTK_CONTAINER(fen), main_hpaned);

  // côté gauche, un vbox contient la liste et dessous les champs
     leftvbox = gtk_vbox_new(FALSE, 2);
     //gtk_container_add (GTK_CONTAINER (main_hpaned), leftvbox);
     gtk_paned_add1 (GTK_PANED (main_hpaned), leftvbox);

    /* la liste des comptes est dans un scrolled window
       pScrollbar = gtk_scrolled_window_new (NULL, NULL);
       gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (pScrollbar),
                                      GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
       gtk_box_pack_start (GTK_BOX (leftvbox), pScrollbar, FALSE, FALSE, 0);
       */
    // la liste
       liste = gtk_clist_new_with_titles (2, titles);
       g_signal_connect (G_OBJECT (liste), "select_row", G_CALLBACK (liste_click), NULL);
       gtk_clist_set_column_width (GTK_CLIST(liste), 0, 90);
       gtk_clist_set_column_width (GTK_CLIST(liste), 1, 40);
       //gtk_box_pack_start (GTK_BOX(leftvbox), liste, FALSE, TRUE, 0);
       //gtk_container_add(GTK_CONTAINER(pScrollbar), liste);
       gtk_box_pack_start (GTK_BOX(leftvbox), liste, FALSE, FALSE, 0);

    // dessous les paires caption/zone de saisie
       table = gtk_table_new (12, 2, FALSE);
       gtk_box_pack_start (GTK_BOX(leftvbox), table, TRUE, TRUE, 0);
  
       txtNom		= Creer_Entry("Nom"        	,1, table);
       txtPOPserveur	= Creer_Entry("Serveur POP"	,2, table);
       txtPOPport	= Creer_Entry("Port POP"   	,3, table);
       txtSMTPserveur	= Creer_Entry("Serveur SMTP"	,4, table);
       txtSMTPport	= Creer_Entry("Port SMTP"   	,5, table);
       txtemail		= Creer_Entry("email"      	,6, table);
       txtMdp		= Creer_Entry("Passe"      	,7, table);
         gtk_entry_set_visibility    (GTK_ENTRY(txtMdp),FALSE);
         gtk_entry_set_invisible_char(GTK_ENTRY(txtMdp), '*');
       txtCheckmn	= Creer_Entry("Check (mn)"      ,8, table);

    // et les boutons
       buttonAdd = gtk_button_new_with_label ("Ajouter");
       g_signal_connect (G_OBJECT (buttonAdd), "clicked", G_CALLBACK (buttonAdd_click), NULL);
       gtk_table_attach_defaults (GTK_TABLE(table), buttonAdd, 0,1, 9,9+1);

       buttonEdit = gtk_button_new_with_label ("Editer");
       g_signal_connect (G_OBJECT (buttonEdit), "clicked", G_CALLBACK (buttonEdit_click), NULL);
       gtk_table_attach_defaults (GTK_TABLE(table), buttonEdit, 1,2, 9,9+1);

       buttonSuppr = gtk_button_new_with_label ("Supprimer");
       g_signal_connect (G_OBJECT (buttonSuppr), "clicked", G_CALLBACK (buttonSuppr_click), NULL);
       gtk_table_attach_defaults (GTK_TABLE(table), buttonSuppr, 0,1, 10,10+1);

       buttonCheck = gtk_button_new_with_label ("Check");
       g_signal_connect (G_OBJECT (buttonCheck), "clicked", G_CALLBACK (buttonCheck_click), NULL);
       gtk_table_attach_defaults (GTK_TABLE(table), buttonCheck, 1,2, 10,10+1);


   // à droite, un vpaned sépare [listview messages et dessous le message]
      rightvpaned = gtk_vpaned_new();
      gtk_paned_add2 (GTK_PANED(main_hpaned), rightvpaned);

      // le treeview a son scrollbar
      pScrollbar = gtk_scrolled_window_new(NULL, NULL);
      gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(pScrollbar),
                                    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
      add_treeview();
      gtk_container_add(GTK_CONTAINER(pScrollbar), pTreeView);
      gtk_paned_add1 (GTK_PANED(rightvpaned), pScrollbar);

      // zone texte pour les messages
      pScrollbar = gtk_scrolled_window_new(NULL, NULL);
      gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(pScrollbar),
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

      text_msg = gtk_text_view_new();
      set_police_couleur(text_msg);
      gtk_container_add (GTK_CONTAINER (pScrollbar), text_msg);

      gtk_paned_add2 (GTK_PANED(rightvpaned), pScrollbar);

  gtk_widget_show_all (fen);

  //gtk_widget_hide (fen);
}
/*==============================================================================
   Initialisation application
==============================================================================*/
static void init_Application()
{
  //printf("init socket\n");
     init_socket();

  // si mails.csv n'existe pas, repart à zero
     if (!file_exists("/usr/local/etc/POPspeech/mails.csv")) reset=1;

  // Charge le tableau de structures
      //printf("lire fichier data ...\n");

  //printf("lire_fichier_data\n");
      lire_fichier_data();

  // pour remplir la liste des comptes
      register int n;
      for (n=0; n<nbboites; n++)
      {
        //SendMessage(hList,LB_ADDSTRING,0,(LONG)b[n].nom);

        gchar num[10];
        sprintf(num, "%d", b[n].nb);
        gchar *compte1[1][2] = {b[n].nom, num};
        gtk_clist_append((GtkCList *)liste, compte1[0]);
      }

  //printf("dossier mails\n");
  // s'assure que le dossier mails existe
      char *folder = "/usr/local/etc/POPspeech/mails";
      if (!is_dir(folder)) mkdir(folder);


  // charge le treeview
     if (reset !=1)
     {
      //printf("csv2listview\n");
      csv2listview();
     }

   // Lance le thread de connection périodique
   //printf("thread connect...\n");
   pthread_t t;
   int iret1 = pthread_create( &t, NULL, thread_check, NULL);
   //pthread_join(t, NULL);
}
/*==============================================================================

==============================================================================*/
int main (int argc, char ** argv)
{
  gtk_init (&argc, &argv);
  create_window();
  init_Application();
  gtk_main();
  return 0;
}
