#include "treeview.h"

GtkTreeStore *pTreeStore;

/*==============================================================================
  tri
==============================================================================*/
void onColumnClick(GtkWidget *widget, gpointer user_data)
//void onColumnClick(GtkTreeViewColumn *treeviewcolumn, gpointer user_data)
{
 
  int id = (int)user_data;
  printf("clic %d\n", id);

  GtkTreeModel* model = gtk_tree_view_get_model(GTK_TREE_VIEW(pTreeView));
  GtkTreeSortable *sortable;
  sortable = GTK_TREE_SORTABLE(model);

  static gboolean flag = FALSE;
  if (flag)
   gtk_tree_sortable_set_sort_column_id(sortable, id, GTK_SORT_ASCENDING);
  else
   gtk_tree_sortable_set_sort_column_id(sortable, id, GTK_SORT_DESCENDING);
  flag = !flag;
}

/*==============================================================================

==============================================================================*/
void listview_add_enregistrement(gchar *from, gchar *to, gchar *sujet,
                                 gchar *date, gchar *idmail)
{
  GtkTreeIter    iter;
  GdkPixbuf *pPixBufA;

  pPixBufA = gdk_pixbuf_new_from_file("/usr/local/etc/POPspeech/img/email.png", NULL);

  /* Creation de la nouvelle ligne */
  gtk_tree_store_append(pTreeStore, &iter, NULL);

  /* Mise a jour des donnees */
  gtk_tree_store_set(pTreeStore, &iter,
            BMP_COLUMN, pPixBufA,
            FROM_COLUMN, from,
            TO_COLUMN, to,
            SUJET_COLUMN, sujet,
            DATE_COLUMN, date,
            IDMAIL_COLUMN, idmail,
            -1);

  g_object_unref(pPixBufA);

  /* pièces jointes
        for(j = 0 ; j < 2 ; ++j)
        {
            g_sprintf(sTexte, "Repertoire %d", j);

            /* Creation de la nouvelle ligne enfant * /
            gtk_tree_store_append(pTreeStore, &pIter2, &pIter);

            /* Mise a jour des donnees * /
            gtk_tree_store_set(pTreeStore, &pIter2,
                BMP_COLUMN, pPixBufB,
                TEXT_COLUMN, sTexte,
                -1);
        }
  */
/*
  char row_num[6];
  sprintf(row_num, "%d", treeview_num_records+3);
  GtkTreePath *path = gtk_tree_path_new_from_string(row_num);
  gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW (pTreeView), path, NULL, TRUE, 0.0, 0.0);
  gtk_tree_view_set_cursor(GTK_TREE_VIEW (pTreeView), path, NULL, FALSE);
*/
}
/*==============================================================================

==============================================================================*/
void add_colonne(gchar* texte, int icol, gint width)
{
  GtkCellRenderer *pCellRenderer;
  GtkTreeViewColumn *pColumn;

  pCellRenderer = gtk_cell_renderer_text_new();
  pColumn = gtk_tree_view_column_new_with_attributes(texte, pCellRenderer,
                 "text", icol, NULL);
  gtk_tree_view_column_set_resizable(pColumn,TRUE);
  gtk_tree_view_column_set_sizing (pColumn, GTK_TREE_VIEW_COLUMN_FIXED);

  gtk_tree_view_column_set_sort_indicator(GTK_TREE_VIEW_COLUMN (pColumn), TRUE);
  gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN (pColumn), icol);

  gtk_tree_view_column_set_fixed_width (pColumn, width);
  gtk_tree_view_append_column(GTK_TREE_VIEW(pTreeView), pColumn);
}
/*==============================================================================

==============================================================================*/
void add_treeview()
{
  GtkCellRenderer *pCellRenderer;
  GtkTreeViewColumn *pColumn;
  //GtkWidget *pScrollbarTxtview;

    /* Creation du modele */
    pTreeStore = gtk_tree_store_new(N_COLUMN,
      GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);

    /* Creation de la vue */
    pTreeView = gtk_tree_view_new_with_model(GTK_TREE_MODEL(pTreeStore));

    /* Creation de la premiere colonne : image */
    pCellRenderer = gtk_cell_renderer_pixbuf_new();
    pColumn = gtk_tree_view_column_new_with_attributes("",
        pCellRenderer, "pixbuf", BMP_COLUMN, NULL);
    gtk_tree_view_column_set_max_width(pColumn, 60);
    gtk_tree_view_append_column(GTK_TREE_VIEW(pTreeView), pColumn);

    add_colonne("De"   , FROM_COLUMN, 100);
    g_signal_connect(pColumn, "clicked", G_CALLBACK(onColumnClick),(gpointer)1);

    add_colonne("Pour" , TO_COLUMN, 60);
    g_signal_connect(pColumn, "clicked", G_CALLBACK(onColumnClick),(gpointer) 2);

    add_colonne("Sujet", SUJET_COLUMN, 210);
    g_signal_connect(pColumn, "clicked", G_CALLBACK(onColumnClick), (gpointer)3);

    add_colonne("Date" , DATE_COLUMN, 160);
    g_signal_connect(pColumn, "clicked", G_CALLBACK(onColumnClick),(gpointer) 4);

    add_colonne("id"   , IDMAIL_COLUMN, 40);
    g_signal_connect(pColumn, "clicked", G_CALLBACK(onColumnClick), (gpointer)5);

  set_police_couleur(pTreeView);

  //gtk_tree_view_set_fixed_height_mode (GTK_TREE_VIEW(pTreeView),TRUE);

  g_signal_connect(pTreeView, "button-press-event", G_CALLBACK(TreeView_Click), NULL);

}

/* =============================================================================
   Clic sur le TreeView
==============================================================================*/
gboolean TreeView_Click (GtkWidget *TV, GdkEventButton *event, gpointer userdata)
{
  GtkTreePath 	*path;
  gchar		*to=NULL, *idmail=NULL;
  //gint id;
  GtkTreeIter SelIter;	// iter sélectionné

  GtkTreeModel* model = gtk_tree_view_get_model(GTK_TREE_VIEW(TV));

  if (gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(TV),(gint) event->x,
				(gint) event->y, &path, NULL, NULL, NULL))
  {
    if (gtk_tree_model_get_iter(model, &SelIter, path))
    {
      gtk_tree_model_get (model, &SelIter, 2,&to, 5,&idmail, -1);
      if (event->button == 1) // clic gauche
      {
	  GtkTextIter tit;
	  gchar *buf=NULL;
          char fic[64];
          sprintf(fic, "/usr/local/etc/POPspeech/mails/%s/%s.txt", to, idmail);

          if (g_file_get_contents (fic, &buf, NULL, NULL))
	  {
            GtkTextBuffer *pTxM = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_msg));
	    gtk_text_buffer_set_text (pTxM,"",0);
	    gtk_text_buffer_get_end_iter(pTxM, &tit);
            gtk_text_buffer_insert (pTxM, &tit, buf, -1);
	  }

      }
    }
  }
  return FALSE;
}
/*==============================================================================

==============================================================================*/
void set_police_couleur(GtkWidget *x)
{
  PangoFontDescription *font_desc;
  GdkColor color;

  // police
  font_desc = pango_font_description_from_string ("Mono 9");
  gtk_widget_modify_font (x, font_desc);
  pango_font_description_free (font_desc);

  // Couleur du fond
  gdk_color_parse ("#000000", &color);
  gtk_widget_modify_base (x, GTK_STATE_NORMAL, &color);

  // couleur du texte
  gdk_color_parse ("#009900", &color);
  gtk_widget_modify_text (x, GTK_STATE_NORMAL, &color);
}

